﻿using DocumentFormat.OpenXml.EMMA;
using GrapeCity.Documents.Word;
using System.Diagnostics;


GcWordDocument doc = new GcWordDocument();
    doc.Body.AddParagraph(@" {{ds.Title}}
                                        {{#ds.Items}}{{ds.Items}:hide-block-if-empty()}  
                                            Name: {{ds.Items.Name}}
                                            I'm should not be here if items is empty
                                        {{/ds.Items}}");
    var model = new Model();
    doc.DataTemplate.DataSources["ds"] = model;
    doc.DataTemplate.Process();
    //var text = doc.Body.Paragraphs.First.GetRange().Text;
   // Console.WriteLine(text); // --------> Content is rendered with one item in list <------------
doc.Save("result.docx");


    GcWordDocument doc2 = new GcWordDocument();
    doc2.Body.AddParagraph(@" {{ds.Title}}
                                        {{#ds.Items}}  
                                            Name: {{ds.Items.Name}:hide-block-if-empty()}
                                            I'm should not be here if items is empty
                                        {{/ds.Items}}");

    var model2 = new Model();
    model2.Items.Add(new Item() { Name = "Item 1" });
    model2.Items.Add(new Item() { Name = "Item 2" }); // comment this LINE  --> Item 1 is not rendered with only one item in LIST document contains no paragraph
    doc2.DataTemplate.DataSources["ds"] = model2;
    doc2.DataTemplate.Process();
    //var text2 = doc2.Body.Paragraphs.First.GetRange().Text;
    //Console.WriteLine(text2);
doc2.Save("result2.docx");

Process.Start(new ProcessStartInfo() { UseShellExecute = true, FileName="result.docx" });
Process.Start(new ProcessStartInfo() { UseShellExecute = true, FileName = "result2.docx" });
public class Model
{
    public string Title { get; set; } = "Sequence Test";
    public List<Item> Items = new List<Item>();
}

public class Item
{
    public string Name
    {
        get;
        set;
    }
}